/**
 * Created with JetBrains PhpStorm.
 * User: kasi
 * Date: 15.05.12
 * Time: 12:56
 * To change this template use File | Settings | File Templates.
 */
QTom.PAGE_STATE_CONTROLLER = 'state-controller';
QTom.PAGE_STATE_CHANNEL_SELECTION = 'state-channel-selection';
QTom.PAGE_STATE_NORMAL = 'state-normal';
QTom.PAGE_STATE_INITIAL = 'state-initial';

QTom.MainPage = Tx.extend(Tx.Page, {
    defaultItem: 'player-control',
    state:QTom.PAGE_STATE_NORMAL,
    fullscreen:false,
    initComponent: function(){
        Tx.Page.prototype.initComponent.apply(this, arguments);
        this.add(new QTom.WorldMenu({element:'world-menu',ref:'worldMenu', down:this.onKey, right:this.onKey, left:'login-button', scope:this}));
        this.add(new QTom.ChannelController({element:'channel-controller', ref:'channelController', 'left':'current-video'}));
        this.add(new QTom.ChannelSelection({element:'channel-selection', ref:'channelSelection', right:'channel-selection-exit', left:this.onKey, scope:this, contentEl:'channel-selection-content-scroller'}));
        this.add(new QTom.QPlaylist({element:'video-preview', ref:'playlist',left:'current-video', up:this.onKey, right:QTom.hasExitButton() ? 'application-exit' : null, scope:this}));
        this.add(new QTom.PlayerControl({element:'playercontrol', ref:'playercontrol', left:this.onKey, down:this.onKey, up:this.onKey, right:QTom.hasExitButton() ? 'application-exit' : null, scope:this}));
        this.add(new QTom.CurrentVideo({element:'current-video', ref:'currentVideo', left:this.onKey, up:this.onKey,right:this.onKey, scope:this}));
        this.add(new Tx.Component({element:'login-button', right:'world-menu',action:'login', removeSelected:true}));
        this.add(new Tx.Component({element:'channel-selection-exit',left:'channel-selection', ref:'channelSelectionExit', action:'exit', removeSelected:true}));
        this.add(new Tx.Component({element:'application-exit', left:this.onKey ,action:'application-exit', removeSelected:true}));
        this.qtomPlusButton = QTom.qtomPlusButton;
        this.add(this.qtomPlusButton);
        this.qtomPlusButton.down = this.onKey.bind(this);
        this.qtomPlusButton.left = this.onKey.bind(this);
        this.qtomPlusButton.addEvent('hide', this.onQtomPlusButtonHide, this);
        //this.add(new Tx.Component({element:'qtom-button', down:'world-menu'}));
        this.worldMenu.addEvent('action', this.handleWorldSelection, this);
        this.channelController.addEvent('action', this.handleControllerAction, this);
        this.channelSelection.addEvent('select', this.handleChannelSelectionAction, this);
        this.playercontrol.addEvent('action', this.handlePlayerControlAction, this);
        this.playlist.addEvent('action', this.onAction, this);
        QTom.setExitButtonDisplay();
    },
    onStartImprint: function() {
        this.isImprint = true;
        this.playercontrol.hide();
    },
    onEndImprint: function() {
        this.isImprint = false;
        this.playercontrol.show();
    },
    onQtomPlusButtonHide: function() {
        if (!this.fullscreen){
            if (this.currentItem == 'qtom-plus' ){
                this.setFocus('playercontrol');
                this.playercontrol.updateFocus();
            }
            else {
                this.currentItem = 'playercontrol';
            }
        }
        else {
            TXApplication.fullscreenPlayerControl.setFocus('fullscreen-button-qme');
        }
    },
    afterLoad: function() {
        this.setPageState(QTom.PAGE_STATE_NORMAL);
        this.setFocus('playercontrol');
        this.playercontrol.setFocus(this.channel.hasControllers() ? 'button-qme' : 'button-fullscreen');
    },
    setPageState: function(state){
        this.element.removeClass(this.state);
        this.state = state;
        this.element.addClass(state);
        switch(state){
            case QTom.PAGE_STATE_INITIAL:
                Tx.fly('channel-controller').show();
                Tx.fly('channel-selection').hide();
                Tx.fly('video-preview-wrapper').hide();
                if (this.channel){
                    this.channelController.setChannel(this.channel);
                }
                break;
            case QTom.PAGE_STATE_CONTROLLER:
                QTom.setExitButtonDisplay(true);
                this.worldMenu.canMinimize = true;
                Tx.fly('channel-controller').show();Tx.fly('channel-selection').hide();Tx.fly('video-preview-wrapper').hide();
                this.setFocus('channel-controller');
                if (this.channel){
                    this.channelController.setChannel(this.channel);
                }
                this.channelController.setFocus('channel-controller-1');
                break;
            case QTom.PAGE_STATE_CHANNEL_SELECTION:
                QTom.setExitButtonDisplay(false);
                this.worldMenu.canMinimize = false;
                Tx.fly('channel-controller').hide();Tx.fly('channel-selection').show();Tx.fly('video-preview-wrapper').hide();
                break;
            case QTom.PAGE_STATE_NORMAL:
                QTom.setExitButtonDisplay(true);
                this.worldMenu.canMinimize = true;
                Tx.fly('channel-controller').hide();Tx.fly('channel-selection').hide();Tx.fly('video-preview-wrapper').show();
                break;
        }
    },
    onKey: function(key, current){
        switch (key){
            case TX_KEY_RIGHT:
                switch(current.id){
                    case 'world-menu':
                        switch(this.state){
                            case QTom.PAGE_STATE_NORMAL:
                                if (this.isImprint){
                                    return null;
                                }
                                this.playercontrol.setFocus('button-qme');
                                this.worldMenu.clearSelection();
                                return 'playercontrol';
                            case QTom.PAGE_STATE_CHANNEL_SELECTION: return 'channel-selection';
                        }
                        break;
                    case 'current-video':
                        switch(this.state){
                            case QTom.PAGE_STATE_NORMAL:
                                this.playlist.focusIndex = 0;
                                return 'video-preview';
                            case QTom.PAGE_STATE_CHANNEL_SELECTION:
                                return 'channel-selection';
                            case QTom.PAGE_STATE_CONTROLLER:
                                this.channelController.currentItem = 'channel-controller-1';
                                return 'channel-controller';
                        }
                        break;
                }
                break;
            case TX_KEY_LEFT:
                switch(current.id){
                    case 'playercontrol':
                        this.worldMenu.focusLastItem();
                        return 'world-menu';
                    case 'channel-selection':
                        //this.worldMenu.clearSelection();
                        return 'world-menu';
                    case 'current-video':
                        if (this.state == QTom.PAGE_STATE_CONTROLLER) {
                            this.setPageState(QTom.PAGE_STATE_NORMAL);
                        }
                        return 'login-button';
                    case 'application-exit':
                        this.playercontrol.currentItem = 'button-fullscreen';
                        return 'playercontrol';
                    case 'qtom-plus':
                        return this.fullscreen ? null :'world-menu';
                }
                break;
            case TX_KEY_DOWN:
                switch(current.id){
                    case 'playercontrol':
                        if (this.state == QTom.PAGE_STATE_NORMAL){
                            if (this.playercontrol.currentItem == 'button-qme' || this.playercontrol.currentItem == 'button-playlist'){
                                this.playlist.focusIndex = 0;
                            }
                            else {
                                this.playlist.focusIndex = 1;
                            }
                            return 'video-preview';
                        }
                        break;
                    case 'world-menu':
                        this.worldMenu.clearSelection();
                        return 'current-video';
                    case 'qtom-plus':
                        return this.fullscreen ? null :'playercontrol';
                }
                break;
            case TX_KEY_UP:
                switch(current.id){
                    case 'video-preview':
                        if (this.playlist.focusIndex == 0){
                            this.playercontrol.currentItem = 'button-qme';
                        }
                        else if(this.playlist.focusIndex == 1){
                            this.playercontrol.currentItem = 'button-skip';
                        }
                        else {
                            this.playercontrol.currentItem = 'button-fullscreen';
                        }
                        return 'playercontrol';
                    case 'current-video':
                        this.worldMenu.focusLast();
                        if (this.state == QTom.PAGE_STATE_CONTROLLER) {
                            this.setPageState(QTom.PAGE_STATE_NORMAL);
                        }
                        return 'world-menu';
                    case 'playercontrol':
                        return this.qtomPlusButton.visible ? 'qtom-plus' :null;
                        break;
                }
                break;
        }
    },
    handleControllerAction: function(component, action, item){
        if (this.fullscreen){
            return;
        }
        switch(action){
            case 'cancel':
                this.setPageState(QTom.PAGE_STATE_NORMAL);
                this.setFocus('playercontrol');
                this.playercontrol.setFocus('button-qme');
                this.resetSubchannel();
                break;
            case 'accept':
                var subChannel = this.channelController.getValue();
                this.setPageState(QTom.PAGE_STATE_NORMAL);
                this.setFocus('playercontrol');
                this.playercontrol.setFocus('button-qme');
                if (this.subChannel !== subChannel){
                    this.subChannel = subChannel;
                    this.loadPlaylist(this.channel, subChannel);
                    QTom.subChannelVideoCounter = 0;
                }
                break;
        }

    },
    resetSubchannel: function() {
        this.channelController.setSubchannel(this.subChannel || '333');
    },
    setWorlds: function(data){
        var worlds = [], i, l, world;
        for (i=0, l=data.length; i<l; i++){
            world = data[i];
            if (!world.hidden){
                worlds.push(world);
            }
        }
        this.worldMenu.setData(worlds);
    },
    setHiddenWorld: function(world){
        var channels = world.getChannels();
        this.channelSelection.setHeader(world.name);
        this.channelSelection.setChannels(channels);
        this.setFocus('channel-selection');
        this.channelSelection.focusItem(0);
        this.setPageState(QTom.PAGE_STATE_CHANNEL_SELECTION);
    },
    handleWorldSelection: function(component, item) {
        if (!item.world){
            return;
        }
        if (item.world.isImprint){
            this.fireEvent('action',['imprint']);
            return;
        }
        var world = item.world, channels = world.getChannels();
        //if (!Tx.Device.isNetcast()){
        //    QTom.setWorldImages(world);
        //}
        this.channelSelection.setHeader(world.name);
        this.channelSelection.setChannels(channels);
        this.setFocus('channel-selection');
        this.channelSelection.focusItem(0);
        this.setPageState(QTom.PAGE_STATE_CHANNEL_SELECTION);
    },
    handleChannelSelectionAction: function(component, channel){
        this.setChannel(channel);
        this.setPageState(QTom.PAGE_STATE_NORMAL);
        this.setFocus('playercontrol');
        this.worldMenu.clearSelection();
    },
    handlePlayerControlAction: function(component, action, data, button) {
        if (TXApplication.playingAd){
            return;
        }
        switch(action){
            case 'qme':
                if (button.enabled) {
                    this.setPageState(QTom.PAGE_STATE_CONTROLLER);
                    this.setFocus('channel-controller');
                    this.channelController.setFocus('channel-controller-1');
                    this.channelController.setSubchannel(this.subChannel);
                }
                else {
                    this.fireEvent('action', ['noqme'])
                }
                break;
            case 'fullscreen':
                this.fireEvent('action', ['fullscreen']);
                break;
            case 'skip':
                this.skipCurrentAsset();
                break;
            case 'share':
                this.fireEvent('action',['share']);
                break;
            case 'playlist':
                if (this.currentAsset && this.currentAsset.isMusicClip()){
                    if (QTom.isRemoveState){
                        this.fireEvent('action',['removefromplaylist', this.channel, this.currentAsset]);
                    }
                    else {
                        this.fireEvent('action',['addtoplaylist', this.currentAsset]);
                    }
                }
        }
    },
    skipCurrentAsset: function() {
        if (this.skipping) return;
        if (this.currentAsset && this.currentAsset.canSkip()){
            this.skipping = true;
            QTom.assetInfo.hide(true);
            QTom.qtomPlusButton.hide(true);
            if (this.currentAsset.isMusicClip()){
                this.playlist.scrollLeftByOne(function(){
                    this.loadPlaylistForAsset(this.playlist.getNextItem());
                }, this);
            }
            else {
                this.loadPlaylistForAsset(this.playlist.getNextItem());
            }
        }
    },
    setHiddenChannel: function(channel, callback, scope){
        this.setChannel(channel, callback, scope);
    },
    setChannel: function(channel, callback, scope, clipId){
        if (this.channel && this.channel.id == channel.id && !channel.userGenerated){
            return;
        }
        /*
        if (channel.isPremium() && !QTom.isPremiumUser()){
            this.fireEvent('action',['notpremium']);
            return;
        }
        */
        /*
        QTom.setPlaylistRemoveState(channel.isUserChannel());
        this.playercontrol.setQmeState(channel.hasControllers());
        this.fireEvent('action', ['qmestate', channel.hasControllers(), channel]);
        this.updateChannel(channel);
        QTom.channelVideoCounter = 0;
        QTom.subChannelVideoCounter = 0;
        */
        this.loadPlaylist(channel, channel.getDefaultSubchannel(), function(){
            this.setFocus('playercontrol');
            if (this.channel && this.channel.hasControllers()){
                this.playercontrol.setFocus('button-qme');
            }
            else {
                this.playercontrol.setFocus('button-fullscreen');
            }
            if (typeof callback == 'function'){
                callback.call(scope || this);
            }
        }, this, clipId);
    },
    updateChannel: function(channel, subchannel){
        if (this.channel && this.channel.id == channel.id){
            return;
        }
        this.channel = channel;
        this.subChannel = subchannel || channel.getDefaultSubchannel();
        QTom.setChannelImages(channel);
    },
    setPlaylist: function(playlist){
        this.currentPlaylist = playlist;
        this.playlist.setAssets(this.currentPlaylist);
    },
    setChannelAndPlaylist: function(channel, subchannel, playlist, noAutoplay){
        this.updateChannel(channel, subchannel);
        this.setPlaylist(playlist);
        if (!noAutoplay){
            this.fireEvent('action', ['playasset', this.currentPlaylist[0]]);
        }
    },
    loadPlaylist: function(channel, subchannel, callback, scope, clipId){
        //this.setPageState(QTom.PAGE_STATE_NORMAL);
        if (!this.fullscreen){
            QTom.showLoading('playlist');
        }
        else {
            QTom.showLoading(Tx.getBody());
        }
        QTom.getPlaylist(channel, subchannel, function(playlist){
            QTom.hideLoading();
            if (Tx.typeOf(playlist) != 'array' || playlist.length == 0){
                return;
            }
            QTom.setPlaylistRemoveState(channel.isUserChannel());
            this.playercontrol.setQmeState(channel.hasControllers());
            this.fireEvent('action', ['qmestate', channel.hasControllers(), channel]);
            this.updateChannel(channel, subchannel);
            QTom.channelVideoCounter = 0;
            QTom.subChannelVideoCounter = 0;
            this.setPlaylist(playlist);
            if (typeof callback == 'function'){
                callback.call(scope || this);
            }
            this.fireEvent('action', ['playasset', this.currentPlaylist[0]]);
        }, QTom.requestError, this, clipId);
    },
    loadPlaylistForAsset: function(asset, callback, scope){
        if (!this.channel){
            return;
        }
        var startTime = Number(asset.startTime), duration = Number(asset.duration) * 1000;
        //this.setPageState(QTom.PAGE_STATE_NORMAL);
        QTom.showLoading(this.fullscreen ? Tx.getBody() : 'playlist');
        if (asset.isMusicClip()){
            this.currentVideo.setAsset(asset);
        }
        QTom.getUpdatePlaylist(this.channel, this.subChannel || this.channel.getDefaultSubchannel(), startTime+duration, function(playlist){
            QTom.hideLoading();
            if (Tx.typeOf(playlist) != 'array' || playlist.length == 0){
                return;
            }
            this.currentPlaylist = playlist;
            this.playlist.setAssets(this.currentPlaylist);
            if (typeof callback == 'function'){
                callback.call(scope || this);
            }
            this.fireEvent('action', ['playasset', this.currentPlaylist[0]]);
        }, function() {
            //failure
            QTom.hideLoading();
            QTom.requestError();
        }, this);

    },
    loadNextAsset: function(callback, scope){
        this.playlist.scrollLeftByOne(function() {
            this.loadPlaylistForAsset(this.playlist.getNextItem(), callback, scope);
        }, this);
    },
    updatePlaylist: function(callback, scope){
        if (this.channel){
            this.loadPlaylist(this.channel, this.subChannel || this.channel.getDefaultSubchannel(), callback, scope);
        }
    },
    setCurrentAsset: function(asset) {
        var canSkip = asset.canSkip(), method = canSkip ? 'removeClass' : 'addClass' ;
        Tx.fly('button-skip')[method]('disabled');
        Tx.fly('fullscreen-button-skip')[method]('disabled');
        Tx.fly('video-preview')[method]('disabled');
        if (!asset.isMusicClip()){
            Tx.fly('button-share').addClass('disabled');
            Tx.fly('fullscreen-button-share').addClass('disabled');
            Tx.fly('button-playlist').addClass('disabled');
            Tx.fly('fullscreen-button-playlist').addClass('disabled');
        }
        else {
            Tx.fly('button-share').removeClass('disabled');
            Tx.fly('fullscreen-button-share').removeClass('disabled');
            Tx.fly('button-playlist').removeClass('disabled');
            Tx.fly('fullscreen-button-playlist').removeClass('disabled');
        }
        this.currentAsset = asset;
        this.currentVideo.setAsset(asset.isMusicClip() ? asset : this.playlist.getFirstMusicClip());
        QTom.setUpperThird(asset);
        if (this.fullscreen){
            this.skipping = false;
            return;
        }
        if (this.currentItem == 'current-video' && this.state == QTom.PAGE_STATE_NORMAL){
            return;
        }
        if (this.skipping){
            this.skipping = false;
            this.setFocus('playercontrol');
            this.playercontrol.setFocus('button-skip');
        }
        /*
        else {
            if (this.state != QTom.PAGE_STATE_CHANNEL_SELECTION){
                this.setFocus('playercontrol');
                if (this.channel && this.channel.hasControllers()){
                    this.playercontrol.setFocus('button-qme');
                }
                else {
                    this.playercontrol.setFocus('button-fullscreen');
                }
            }
        }
        */
    },
    onAction: function(component){
        Tx.warn('page.onAction', TXApplication.playingAd);
        if (TXApplication.playingAd) {
            return;
        }
        switch(component.id) {
            case 'current-video':
                if (this.state != QTom.PAGE_STATE_NORMAL){
                    this.setPageState(QTom.PAGE_STATE_NORMAL);
                }
                this.fireEvent('action',['toggleplaypause']);
                return true;
            case 'video-preview':
                if (this.currentAsset && this.currentAsset.canSkip()){
                    QTom.qtomPlusButton.hide();
                    QTom.assetInfo.hide();
                    var focusItem = component.getFocusItem();
                    if (focusItem.disabled || focusItem.asset.disabled) {
                        return true;
                    }
                    this.playlist.scrollLeft(focusItem, function(){
                        this.currentVideo.setAsset(focusItem.asset);
                        this.setFocus('current-video');
                        this.loadPlaylistForAsset(focusItem.asset);
                    },this);
                    return true;
                }
                break;
            case 'channel-selection-exit':
                this.setPageState(QTom.PAGE_STATE_NORMAL);
                this.worldMenu.clearSelection();
                this.setFocus('world-menu');
                break;
            case 'qtom-plus':
                this.fireEvent('action', ['qtomplus']);
                return true;
                break;
        }

    }
});
QTom.LoginPage = Tx.extend(Tx.Page, {
    element:'login',
    defaultItem: 'login-field',
    initComponent: function() {
        Tx.Page.prototype.initComponent.apply(this, arguments);
        /*todo Samsung entfernen wenn eingeloggt bleiben funktioniert */
        if (Tx.Device.isSamsung()){
            this.add(QTom.NumberField, {element:'login-field',input:'login-field-value', right:'login-clear', left:'login-mail-button', ref:'inputField', removeSelected:true});
            this.add(Tx.Component, {element:'login-clear', right:'login-button-ok',left:'login-field', down:null, action:'clear', removeSelected:true});
            this.add(Tx.Component, {element:'login-button-ok', right:'login-button-cancel',left:'login-clear', down:null, action:'ok', removeSelected:true});
            this.add(Tx.Component, {element:'login-button-cancel', left:'login-button-ok', action:'cancel', removeSelected:true});
            this.add(QTom.Checkbox, {element:'login-checkbox', up:'login-button-ok', ref:'inputCheckbox', right:'login-button-cancel', checked:true, removeSelected:true});
            this.add(Tx.Component, {element:'login-mail-button', right:'login-field', down:'impressum-button', action:'showmail', removeSelected:true});
            this.add(Tx.Component, {element:'impressum-button', up:'login-mail-button', right:'login-field', action:'imprint', removeSelected:true});
        }
        else {
            this.add(QTom.NumberField, {element:'login-field',input:'login-field-value', right:'login-clear', left:'login-mail-button', ref:'inputField', removeSelected:true});
            this.add(Tx.Component, {element:'login-clear', right:'login-button-ok',left:'login-field', down:'login-checkbox', action:'clear', removeSelected:true});
            this.add(Tx.Component, {element:'login-button-ok', right:'login-button-cancel',left:'login-clear', down:'login-checkbox', action:'ok', removeSelected:true});
            this.add(Tx.Component, {element:'login-button-cancel', left:'login-button-ok', action:'cancel', removeSelected:true});
            this.add(QTom.Checkbox, {element:'login-checkbox', up:'login-button-ok', ref:'inputCheckbox', right:'login-button-cancel', checked:true, removeSelected:true});
            this.add(Tx.Component, {element:'login-mail-button', right:'login-field', down:'impressum-button', action:'showmail', removeSelected:true});
            this.add(Tx.Component, {element:'impressum-button', up:'login-mail-button', right:'login-field', action:'imprint', removeSelected:true});
        }

        this.errorMessageElement = Tx.get('login-error');
        QTom.updateTextMessage('login');
    },
    getValues: function() {
        return {
            tvcode:this.inputField.getValue(),
            remember:this.inputCheckbox.checked
        };
    },
    reset: function() {
        this.errorMessageElement.setHtml('').hide();
        this.inputField.clear();
    },
    onAction: function(component){
        if (component.action == 'clear'){
            this.inputField.clear();
            this.setFocus('login-field');
            this.errorMessageElement.setHtml('').hide();
            return true;
        }
    },
    onShow: function() {
        QTom.setExitButtonDisplay(false);
        this.errorMessageElement.setHtml('').hide();
        this.setFocus('login-field');
        if (!Tx.Device.hasKeyboard()) {
            Tx.fly(Tx.getBody()).addClass('popuplogin');
        }
    },
    onHide: function() {
        QTom.setExitButtonDisplay(true);
        if (!Tx.Device.hasKeyboard()) {
            Tx.fly(Tx.getBody()).removeClass('popuplogin');
        }
    },
    setErrorMessage: function(message) {
        this.errorMessageElement.setHtml(Tx.htmlspecialchars(message)).show();
    }
});

QTom.LogoutPage = Tx.extend(Tx.Page, {
    element:'logout',
    defaultItem: 'logout-button-ok',
    initComponent: function() {
        Tx.Page.prototype.initComponent.apply(this, arguments);
        this.add(Tx.Component, {element:'logout-button-ok', right:'logout-button-cancel',action:'ok', removeSelected:true});
        this.add(Tx.Component, {element:'logout-button-cancel', left:'logout-button-ok', action:'cancel', removeSelected:true});
        QTom.updateTextMessage('logout');
    },
    onShow: function() {
        QTom.setExitButtonDisplay(false);

    },
    onHide: function() {
        QTom.setExitButtonDisplay(true);
    }
});
QTom.MailPage = Tx.extend(Tx.Page, {
    element:'mail',
    initComponent: function() {
        Tx.Page.prototype.initComponent.apply(this, arguments);
        var limit = (Tx.Device.isNetcast()) ?  32 : (Tx.Device.isToshiba()) ? 18 : 0;
        this.add(QTom.Textfield, {element:'mail-field', input:'mail-field-value', down:'mail-button-ok', right:'mail-clear', ref:'mailField', removeSelected:true, limit: limit});
        this.add(Tx.Component, {element:'mail-clear', left:'mail-field', down:'mail-button-ok', right:'mail-button-cancel', action:'clear', ref:'buttonCancel', removeSelected:true});
        this.add(Tx.Component, {element:'mail-button-ok', right:'mail-button-cancel', up:'mail-field', action:'ok', ref:'buttonOk', removeSelected:true});
        this.add(Tx.Component, {element:'mail-button-cancel', left:'mail-button-ok', up:'mail-clear', action:'cancel', ref:'buttonCancel', removeSelected:true});
        this.mailMessage = Tx.get('mail-message');
        this.mailResult = Tx.get('mail-result');
        this.mailResultHeadline = Tx.get('mail-result-headline');
        this.mailResultText= Tx.get('mail-result-text');
        this.mailField.addEvent('enter', this.onKeyboardEnter, this);
        this.mailField.addEvent('exit', this.onKeyboardExit, this);
        this.errorMessageElement = Tx.get('mail-field-error');
        QTom.updateTextMessage('mail');
    },
    show: function(){
        QTom.setExitButtonDisplay(false);
        this.mailMessage.show();
        this.mailResult.hide();
        this.buttonOk.show();
        this.buttonCancel.left = 'mail-button-ok';
        this.buttonCancel.up = 'mail-clear';
        this.setFocus('mail-field');
        this.errorMessageElement.setHtml('').hide();
        Tx.Page.prototype.show.apply(this, arguments);
    },
    onShow: function(){
        if (!Tx.Device.hasKeyboard()) {
            Tx.fly(Tx.getBody()).addClass('popupmail')
        }
    },
    onHide: function() {
        QTom.setExitButtonDisplay(true);
        this.setFocus('mail-button-ok');
        if (!Tx.Device.hasKeyboard()) {
            Tx.fly(Tx.getBody()).removeClass('popupmail')
        }
    },
    showResult: function(text, headline){
        this.setFocus('mail-button-cancel');
        this.buttonOk.hide();
        this.buttonCancel.left = null;
        this.buttonCancel.up = null;
        this.mailMessage.hide();
        this.mailResult.show();
        this.mailResultHeadline.setHtml(QTom.parseText(headline || ''));
        this.mailResultText.setHtml(QTom.parseText(text || ''));
    },
    getValue: function() {
        return this.mailField.getValue();
    },
    onKeyboardEnter: function() {
        this.setFocus('mail-button-ok');
    },
    onKeyboardExit: function() {
        this.setFocus('mail-button-cancel');
    },
    setErrorMessage: function(text){
        this.errorMessageElement.setHtml(Tx.htmlspecialchars(text)).show();
    },
    onAction: function(component){
        if (component.action == 'clear'){
            this.mailField.clear();
            this.setFocus('mail-field');
        }
    }
});
QTom.NotificationSmall = Tx.extend(Tx.Page, {
    element:'notification-small',
    initComponent: function() {
        Tx.Page.prototype.initComponent.apply(this, arguments);
        this.headline = this.element.query('.header').get(0);
        this.content = this.element.query('.content').get(0);
        this.add(Tx.Component, {element:'notification-small-button-ok', ref:'okButton',right:'notification-small-button-cancel', action:'ok', removeSelected:true});
        this.add(Tx.Component, {element:'notification-small-button-cancel', ref:'cancelButton',left:'notification-small-button-ok', action:'cancel', removeSelected:true});
    },
    show: function(headline, content, ok, callbackdata, callback, callbackScope, titleImage, messageImage, buttonImage, buttonContent) {
        this.cancelButton.show();
        this.callback = callback;
        this.callbackScope = callbackScope;
        this.callbackdata = callbackdata;
        if (ok && typeof ok == 'object'){
            buttonImage = ok.image;
            buttonContent = ok.content;
            ok = ok.text;
        }
        if (typeof headline != 'string'){
            headline = '';
        }
        if (typeof content != 'string'){
            content = '';
        }
        this.headline.setHtml('<h1>'+QTom.parseText(headline)+'</h1>');
        if (titleImage){
            this.headline.insertHtml('<img src="'+titleImage+'" alt="" />','top');
        }
        //this.headline.setStyle('backgroundImage', titleImage ? 'url('+titleImage+')' : '');
        this.content.setHtml(QTom.parseText(content || ''));
        if (messageImage){
            this.content.insertHtml('<img src="'+messageImage+'" alt="" />','top');

        }
        //this.content.setStyle('backgroundImage', messageImage ? 'url('+messageImage+')' : '');
        //this.okButton.setStyle('backgroundImage', buttonImage ? 'url('+QTom.getMediaUrl(buttonImage)+')' : '');
        this.okButton.content = buttonContent;
        if (ok || buttonImage) {
            this.okButton.setHtml(QTom.parseText(ok || ''));
            if (buttonImage){
                this.okButton.element.insertHtml('<img src="'+QTom.getMediaUrl(buttonImage)+'" alt="" />','top');
            }
            this.okButton.show();
            this.cancelButton.left = 'notification-small-button-ok';
            this.setFocus('ok');
        }
        else {
            this.okButton.hide();
            this.cancelButton.left = null;
            this.setFocus('cancel');
        }
        Tx.fly('shim').show();
        Tx.Page.prototype.show.apply(this, arguments);
        this.fireEvent('show');
    },
    setFocus: function(button){
        switch (button){
            case 'notification-small-button-ok':
            case 'ok':
                this.okButton.addClass('focus');
                this.cancelButton.removeClass('focus');
                this.currentItem = 'notification-small-button-ok';
                break;
            case 'notification-small-button-cancel':
            case 'cancel':
                this.okButton.removeClass('focus');
                this.cancelButton.addClass('focus');
                this.currentItem = 'notification-small-button-cancel';
                break;
        }
    },
    onHide: function() {
        Tx.fly('shim').hide();
        this.fireEvent('hide');
    },
    handleKey: function(key){
        Tx.Page.prototype.handleKey.apply(this, arguments);
        return true;
    },
    onAction: function(component) {
        if (typeof this.callback == 'function' && component.action){
            this.callback.call(this.callbackScope || this, component.action, this.callbackdata, component, this);
            return true;
        }
        if (component.action == 'cancel'){
            this.hide();
            return true;
        }
    }
});

QTom.SharePopup = Tx.extend(Tx.Page, {
    defaultItem: 'share-button-ok',
    shareType:'asset',
    initComponent: function() {
        Tx.Page.prototype.initComponent.apply(this, arguments);
        this.image = Tx.get('share-current-video-image');
        this.artist = Tx.get('share-current-video-artist');
        this.title = Tx.get('share-current-video-title');
        this.add(QTom.Textfield, {element:'nachricht-container', input:'nachricht', ref:'message',down:'share-button-ok', right:'share-clear', up:'share-video', removeSelected:true, showOnFocus:true});
        this.add(Tx.Component, {element:'share-button-ok', action:'ok', up:'nachricht-container',right:'share-button-cancel', removeSelected:true});
        this.add(Tx.Component, {element:'share-button-cancel',action:'cancel',left:'share-button-ok', up:'share-clear', removeSelected:true});
        this.add(Tx.Component, {element:'share-clear', action:'clear', left:'nachricht-container',down:'share-button-cancel', up:'share-channel', removeSelected:true});
        this.add(QTom.Checkbox, {element:'share-video', ref:'shareVideo', value:'asset', down:'nachricht-container', right:'share-channel', action:'share-video', checked:true, removeSelected:true, noEvent:false});
        this.add(QTom.Checkbox, {element:'share-channel', ref:'shareChannel', value:'channel', down:'nachricht-container', left:'share-video', action:'share-channel',removeSelected:true, noEvent:false});
        this.message.addEvent('enter', this.onKeyboardEnter,this);
        this.message.addEvent('exit', this.onKeyboardEnter,this);
        this.messageContainer = Tx.get('share-message');
        this.resultContainer = Tx.get('share-result');
    },
    setAsset: function(asset) {
        this.asset = asset;
        this.image.attr('src',asset.getImage('teaserImage'));
        this.artist.setHtml(Tx.htmlspecialchars(asset.artist));
        this.title.setHtml(Tx.htmlspecialchars(asset.title));
    },
    setChannel: function(channel){
        this.channel = channel;
    },
    onHide: function() {
        if (!Tx.Device.hasKeyboard()) {
            Tx.fly(Tx.getBody()).removeClass('popupshare')
        }
        Tx.fly('shim').hide();
        this.message.setFocus(false);
        Tx.SimpleKeyboard.hide();
    },
    onShow: function(){
        if (!Tx.Device.hasKeyboard()) {
            Tx.fly(Tx.getBody()).addClass('popupshare')
        }
        this.shareVideo.setChecked(true);
        this.shareChannel.setChecked(false);
        this.shareType = 'asset';
        this.messageContainer.show();
        this.resultContainer.hide().setHtml('');
        this.message.setFocus(false);
        this.setFocus('nachricht-container');
        this.setFocus('share-button-ok');
        Tx.fly('share-message').show();
        Tx.fly('share-result').hide();
        Tx.fly('shim').show();
    },
    showLoading: function() {
        this.messageContainer.hide();
        this.resultContainer.show();
        QTom.showLoading(this.resultContainer.dom);
    },
    onKeyboardEnter: function(component) {
        if (!Tx.Device.hasKeyboard()){
            this.setFocus('share-button-ok');
        }
    },
    setFocus: function() {
        Tx.Page.prototype.setFocus.apply(this, arguments);
        if (this.currentItem == 'nachricht-container'){
            //this.message.showKeyboard();
        }
        else {
            this.message.hideKeyboard();
        }
    },
    handleKey: function(key){
        if (key == TX_KEY_ENTER){
            var component = this.getComponent();
            if (component.txType == 'textfield' && !component.keyboardVisible){
                component.showKeyboard();
                return true;
            }
        }
        return Tx.Page.prototype.handleKey.apply(this, arguments);
    },
    onAction: function(component){
        switch(component.action){
            case 'chancel': this.fireEvent('action', ['cancel']); return true;
            case 'ok':
                var shareType = this.getShareType(), data = (shareType == 'asset') ? this.asset : this.channel;
                this.fireEvent('action', ['ok', data, this.message.getValue(), this.getShareType()]); return true;
            case 'clear': this.message.clear();this.setFocus('nachricht-container'); return true;
            case 'edit':
                return true;
            case 'share-video':
                this.shareType = 'asset';
                this.shareVideo.setChecked(true);
                this.shareChannel.setChecked(false);
                return true;
            case 'share-channel':
                this.shareType = 'channel';
                this.shareVideo.setChecked(false);
                this.shareChannel.setChecked(true);
                return true;
        }
    },
    showMessage: function(message){
        this.messageContainer.hide();
        this.resultContainer.show().setHtml(message);
        this.setFocus('share-button-cancel');
    },
    getShareType: function() {
        return this.shareType;
    }
});
QTom.HiddenChannelPopup = Tx.extend(Tx.Page, {
    element: 'hidden-channel',
    defaultItem: Tx.Device.isPhilips() ? 'hidden-channel-clear' : 'hidden-channel-field',
    initComponent: function() {
        Tx.Page.prototype.initComponent.apply(this, arguments);
        this.add(QTom.Textfield, {element:'hidden-channel-field', input:'hidden-channel-field-value', right:'hidden-channel-clear', down:'hidden-channel-button-ok', ref:'inputField', removeSelected:true});
        this.add(Tx.Component, {element:'hidden-channel-clear', left:'hidden-channel-field', down:'hidden-channel-button-cancel', right:'hidden-channel-button-cancel', action:'clear', removeSelected:true});
        this.add(Tx.Component, {element:'hidden-channel-button-ok', up:'hidden-channel-field', right:'hidden-channel-button-cancel', action:'ok', removeSelected:true});
        this.add(Tx.Component, {element:'hidden-channel-button-cancel', left:'hidden-channel-button-ok', up:'hidden-channel-clear', action:'cancel', removeSelected:true});
        this.errorMessageElement = Tx.get('hidden-channel-field-error');
        this.inputField.addEvent('enter', this.onKeyboardEnter,this);
        this.inputField.addEvent('exit', this.onKeyboardEnter,this);
        QTom.updateTextMessage('hidden-channel');
    },
    onKeyboardEnter: function() {
        this.setFocus('hidden-channel-button-ok');
    },
    onAction: function(component){
        if (component.action == 'clear'){
            this.inputField.clear();
            this.setFocus('hidden-channel-field');
            return true;
        }
    },
    onShow: function() {
        this.errorMessageElement.hide();
        this.setFocus(Tx.Device.isPhilips() ? 'hidden-channel-clear' : 'hidden-channel-field');
        if (!Tx.Device.hasKeyboard()) {
            Tx.fly(Tx.getBody()).addClass('popuphidden')
        }
    },
    onHide: function() {
        this.inputField.setFocus(false);
        if (!Tx.Device.hasKeyboard()) {
            Tx.fly(Tx.getBody()).removeClass('popuphidden')
        }
    },
    getValue: function() {
        return this.inputField.getValue();
    },
    setErrorMessage: function(text){
        this.errorMessageElement.setHtml(Tx.htmlspecialchars(text)).show();
        this.setFocus('hidden-channel-field');
    }
});
QTom.SmallLoginPopup = Tx.extend(Tx.Page, {
    element:'login-small',
    initComponent: function() {
        Tx.Page.prototype.initComponent.apply(this, arguments);
        /*todo Samsung entfernen wenn eingeloggt bleiben funktioniert */
        if (Tx.Device.isSamsung()){
            this.add(QTom.NumberField, {element:'login-small-field', input:'login-small-field-value', right:'login-small-clear',down:'login-small-button-login', ref:'inputField', removeSelected:true});
            this.add(Tx.Component, {element:'login-small-clear', left:'login-small-field', down:'login-small-button-ok', right:'login-small-button-cancel', action:'clear', removeSelected:true});
            this.add(Tx.Component, {element:'login-small-button-login', up:'login-small-field', right:null, down:'login-small-button-ok', action:'login', removeSelected:true});
            this.add(QTom.Checkbox, {element:'login-small-checkbox', left:'login-small-button-login', up:'login-small-clear', down:'login-small-button-ok', right:'login-small-button-cancel', ref:'inputCheckbox', checked:true, removeSelected:true});
            this.add(Tx.Component, {element:'login-small-button-ok', action:'ok', up:'login-small-button-login', right:'login-small-button-cancel', removeSelected:true});
            this.add(Tx.Component, {element:'login-small-button-cancel', action:'cancel', left:'login-small-button-ok', removeSelected:true});
        }
        else {
            this.add(QTom.NumberField, {element:'login-small-field', input:'login-small-field-value', right:'login-small-clear',down:'login-small-button-login', ref:'inputField', removeSelected:true});
            this.add(Tx.Component, {element:'login-small-clear', left:'login-small-field', down:'login-small-checkbox', right:'login-small-button-cancel', action:'clear', removeSelected:true});
            this.add(Tx.Component, {element:'login-small-button-login', up:'login-small-field', right:'login-small-checkbox', down:'login-small-button-ok', action:'login', removeSelected:true});
            this.add(QTom.Checkbox, {element:'login-small-checkbox', left:'login-small-button-login', up:'login-small-clear', down:'login-small-button-ok', right:'login-small-button-cancel', ref:'inputCheckbox', checked:true, removeSelected:true});
            this.add(Tx.Component, {element:'login-small-button-ok', action:'ok', up:'login-small-button-login', right:'login-small-button-cancel', removeSelected:true});
            this.add(Tx.Component, {element:'login-small-button-cancel', action:'cancel', left:'login-small-button-ok', removeSelected:true});
        }
        this.headerElement = Tx.get('login-small-header');
        this.textElement = Tx.get('login-small-text');
        this.errorMessageElement = Tx.get('login-small-field-error');
        this.inputField.addEvent('enter', this.onKeyboardEnter,this);
        this.inputField.addEvent('exit', this.onKeyboardEnter,this);
        QTom.updateTextMessage('login-small');
    },
    onKeyboardEnter: function() {
        this.setFocus('login-small-button-ok');
    },
    getValues: function() {
        return {
            tvcode:this.inputField.getValue(),
            remember:this.inputCheckbox.checked
        };
    },
    reset: function() {
        this.errorMessageElement.setHtml('').hide();
        this.inputField.clear();
    },
    onShow: function() {
        this.setFocus('login-small-field');
        this.errorMessageElement.setHtml('').hide();
        if (!Tx.Device.hasKeyboard()) {
            Tx.fly(Tx.getBody()).addClass('smalllogin')
        }

    },
    onHide: function() {
        if (!Tx.Device.hasKeyboard()) {
            Tx.fly(Tx.getBody()).removeClass('smalllogin');
            Tx.SimpleKeyboard.hide();
        }
    },
    setMessage: function(message){
        this.headerElement.setHtml(Tx.htmlspecialchars(message.headline || ''));
        this.textElement.setHtml(QTom.parseText(message.text || ''));
    },
    onAction: function(component){
        if (component.action == 'clear'){
            component.setSelected(true);
            this.inputField.clear();
            this.setFocus('login-small-field');
            this.errorMessageElement.setHtml('').hide();
            return true;
        }
    },
    setErrorMessage: function(text){
        this.errorMessageElement.setHtml(Tx.htmlspecialchars(text)).show();
    }
});
