/**
 * Created with JetBrains PhpStorm.
 * User: kasi
 * Date: 15.05.12
 * Time: 12:46
 * To change this template use File | Settings | File Templates.
 */
QTom.USER_STATUS_ANONYMUS = 'ANONYMOUS';
QTom.USER_STATUS_FREEMIUM = 'FREEMIUM';
QTom.USER_STATUS_PREMIUM = 'PREMIUM';
QTom.MAIL_STATUS_ALREADY_EXISTS = 'EMAIL_ADDRESS_ALREADY_EXISTS';
QTom.MAIL_STATUS_OK = 'OK';
QTom.STATUS_OK = 'OK';
QTom.STATUS_EMPTY = 'EMPTY';
QTom.STATUS_ACCESS_DENIED = 'ACCESS_DENIED';
QTom.STATUS_LIMIT_EXCEEDED = 'LIMIT_EXCEEDED';
QTom.STATUS_FAIL = 'FAIL';
QTom.PROVIDER_STATUS_ACTIVE = 'ACTIVE';
QTom.PROVIDER_STATUS_INACTIVE = 'INACTIVE';
QTom.MESSAGE_SHARING_NOT_LOGGED_IN = 'sharing-not-logged-in';
QTom.MESSAGE_SHARING_NO_FACEBOOK = 'sharing-no-facebook';
QTom.MESSAGE_PLAYLIST_NOT_LOGGED_IN = 'playlist-not-logged-in';
QTom.MESSAGE_INFO_EMAIL = 'info-email';
QTom.MESSAGE_INFO_EMAIL_SUCCESS = 'info-email-success';
QTom.MESSAGE_INFO_EMAIL_FAILED = 'info-email-failed';
QTom.MESSAGE_MARKETING = 'login-marketing';
QTom.MESSAGE_WHY_REGISTER = 'login-why-register';
QTom.MESSAGE_LOGIN_INFOTEXT = 'login-infotext';
QTom.MESSAGE_LOGIN_ADVANTAGE_REGISTER = 'login-advantage-register';
QTom.MESSAGE_CONTROLLER_TEXT = 'controller-text';
QTom.MESSAGE_ERROR_NO_SERVER = 'error-no-server';
QTom.MESSAGE_ERROR_GENERAL = 'error-general';
QTom.worlds = [];
QTom.channels = [];
QTom.userStatus = QTom.USER_STATUS_ANONYMUS;
QTom.currentUser = null;
QTom.favoriteChannel = null;
QTom.isRemoveState = false;
QTom.hasBuffering = true;
QTom.currentUpperThird = {};
QTom.pointerDeviceIsActive = false;
QTom.World = Tx.extend(Tx.Base, {
    name: '',
    hidden: false,
    worldImage: null,
    constructor: function(data){
        Tx.Base.prototype.constructor.call(this);
        Tx.apply(this, data);
        this.channels = [];
        var attrs = data['@attributes'];
        if (attrs){
            this.name = attrs.name;
            this.hidden = attrs.isHidden === 'true';
        }
        var channel = data.channel;
        if (!channel){
            return;
        }
        if (Tx.typeOf(channel) !== 'array'){
            channel = [channel];
        }
        for (var i= 0, l=channel.length; i<l; i++){
            this.addChannel(new QTom.Channel(this, channel[i]),true);
        }
    },
    addChannel: function(channel, noEvent){
        if (!channel){
            return;
        }
        QTom.channels.push(channel);
        if (!channel.hidden){
            this.channels.push(channel);
        }
        if (channel.startChannel){
            QTom.startChannel = channel;
        }
        if (channel.isFavorite()){
            QTom.favoriteChannel = channel;
        }
        if (!noEvent){
            this.fireEvent('add',[channel]);
        }
    },
    getChannel: function(id){
        return this.channels[id];
    },
    getChannels: function() {
        return this.channels;
    }
});
QTom.Channel = Tx.extend(Tx.Base, {
    id:null,
    name:'',
    hidden:false,
    world:null,
    controllers:null,
    startChannel:false,
    constructor: function(world, data){
        Tx.Base.prototype.constructor.call(this);
        Tx.apply(this, data);
        this.world = world;
        this.controllers = [];
        var attrs = data['@attributes'];
        if (attrs){
            this.name = attrs.name;
            this.id = attrs.id;
            this.hidden = attrs.isHidden === 'true';
            this.startChannel = attrs.startChannel === 'true';
            this.userGenerated = attrs.userGenerated === 'true';
            this.favorites = attrs.favorites === 'true';
            this.premiumOnly = attrs.premiumOnly === 'true';
        }
        for (var i= 1,controller; i<4; i++){
            controller = this['controller'+i];
            if (controller){
                this.addController(new QTom.Controller(controller));
            }
        }
    },
    getDefaultSubchannel: function() {
        switch(this.controllers.length){
            case 1: return '3';
            case 2: return '33';
            case 3: return '333';
        }
        return '333';
    },
    isFavorite: function() {
        return this.userGenerated && this.favorites;
    },
    isPremium: function() {
        return this.premiumOnly;
    },
    isUserChannel: function() {
        return this.userGenerated;
    },
    addController: function(controller){
        this.controllers.push(controller);
    },
    getControllers: function() {
        return this.controllers;
    },
    hasControllers: function() {
        return this.controllers.length > 0;
    },
    getImage: function(name){
        var img = this[name];
        if (!img){
            return '';
        }
        if (Tx.typeOf(img) == 'array'){
            img = img[0];
        }
        return QTom.mediaBaseUrl+img;
    }
});
QTom.Asset = function(data){
    if (data['@attributes']){
        Tx.apply(this, data['@attributes']);
    }
    Tx.apply(this, data);
    if (Tx.typeOf(this.teaserImage) == 'array'){
        this.teaserImage = this.teaserImage[0];
    }
    if (this.prerollAd){
        Tx.log('prerollAd', this.prerollAd);
    }
    this.playPosition = 0;
    this.adIsPlayed = false;
};
QTom.Asset.prototype.getVideo = function() {
    return {
        url:QTom.getVideoUrl(this.fileName),
        mime: this.mimeType,
        duration:this.duration
    }
};
QTom.Asset.prototype.isAirElement = function() { return this.type == 'onAirElement';};
QTom.Asset.prototype.isMusicClip = function() { return this.type == 'musicClip';};
QTom.Asset.prototype.isEditorialContent = function() { return this.type == 'editorialContent';};
QTom.Asset.prototype.canSkip = function() {return this.isSkipable == 'true';};
QTom.Asset.prototype.hasUpperThird = function(){return !!this.graphic;};
QTom.Asset.prototype.getImage = function(name){
    var img = this[name];
    if (!img){
        return '';
    }
    if (Tx.typeOf(img) == 'array'){
        img = img[0];
    }
    return QTom.mediaBaseUrl+img;
};
QTom.Asset.prototype.getUpperThird = function() {
    if (!this.hasUpperThird()){
        return false;
    }
    else {
        var graphic = this.graphic;
        if (Tx.typeOf(graphic) == 'array'){
            graphic = graphic[0];
        }
        return {
            url: QTom.getMediaUrl(graphic['@attributes'].fileName || graphic.filename),
            fadeInAfter: Number(graphic['@attributes'].fadeInAfter || graphic.fadeInAfter || 0),
            fadeOutBefore: Number(graphic['@attributes'].fadeOutBefore || graphic.fadeOutBefore || 0)
        };
    }
};
QTom.Asset.prototype.hasAd = function() {
    return !! this.prerollAd;
};
QTom.Asset.prototype.getPrerollAd = function() {
    return this.prerollAd ? this.prerollAd : '';
};
QTom.Asset.prototype.isAdPlayed = function() {
    return this.adIsPlayed;
};
QTom.Asset.prototype.setAdPlayed = function(state){
    this.adIsPlayed = !! state;
};
QTom.Controller = Tx.extend(Tx.Base, {
    infoImage:'',
    left:'',
    right:'',
    constructor: function(data){
        var attrs = data['@attributes'];
        if (attrs){
            Tx.apply(this, attrs);
        }
    }
});
QTom.Playlist = Tx.extend(Tx.Base, {

});
QTom.Notification = function(data){
    Tx.apply(this, data);
};
/**
 * QTom Server Requests
 */
Tx.apply(QTom, {
    mediaBaseUrl: 'http://qtom.dyndns.tv',// 'http://qtom.tv/',
    requestId:0,
    sessionId:null,
    loggedIn: false,
    notifications: [],
    requestError: function(xhr, data){
        Tx.error('requesterror', xhr, data);
        QTom.hideLoading();
    },
    setPointerDeviceIsActive: function(state) {
        Tx.log('QTom.setPointerDeviceIsActive: ', state);
        QTom.pointerDeviceIsActive = state;
    },
    setNotifications: function(data, noAutoplay){
        if (!data) return;
        if (data.notification){
            data = data.notification;
        }
        if (Tx.typeOf(data) != 'array'){
            data = [data];
        }
        for (var notification, i=0, l=data.length; i<l; i++){
            notification = data[i];
            if (notification.notification){
                notification = notification.notification;
            }
            if (notification.titleText && notification.messageText){
                QTom.notifications.push(new QTom.Notification(notification));
            }
        }
        if (noAutoplay !== true){
            QTom.showNotifications.delay(1000, QTom);
        }
    },
    setUserStatus: function(data){
        if (!data || !data['user-status']){
            return;
        }
        var status = data['user-status'], body = Tx.getBody();
        QTom.userStatus = status.status ? status.status : QTom.USER_STATUS_ANONYMUS;
        QTom.sessionId = status['session-token'] ? status['session-token'] : '';
        if (QTom.userStatus != QTom.USER_STATUS_ANONYMUS && QTom.sessionId){
            QTom.loggedIn = true;
            TXApplication.setLoginState(true);
        }
        else {
            QTom.loggedIn = false;
            TXApplication.setLoginState(false);
        }
        if (QTom.userStatus == QTom.USER_STATUS_PREMIUM){
            Tx.fly(body).addClass('premium');
        }
        else {
            Tx.fly(body).removeClass('premium');
        }
    },
    init: function(clipId, success, failure, scope){
        Tx.log('initcall');
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[deviceId]':QTom.getDeviceId(),
                'params[clipId]':clipId || '',
                action:'App_Service_Flake',
                method:'init'
            },
            failure: function(xhr){
                Tx.log('initcall failure', xhr);
                if (typeof  failure == 'function'){
                    failure.call(scope, xhr);
                }
            },
            success:function(xhr, result){
                Tx.log('initcall success', result, result.result.config, result.result.error, result.result.flakeConfig);
                var i, l, id;
                if (result.error || result.result.error){
                    failure.call(scope, xhr,result, result.error || result.result.error);
                }
                else {
                    var data = result.result;
                    Tx.apply(TXConfig, data.config);
                    if (data.config.qtom){
                        Tx.apply(QTom, data.config.qtom);
                    }
                    if (data.flake){
                        var worlds = data.flake.world;
                        QTom.worlds = [];
                        QTom.channels = [];
                        for (i= 0, l=worlds.length; i<l; i++){
                            QTom.worlds.push(new QTom.World(worlds[i])) ;
                        }
                        QTom.setNotifications(data.flake.notifications);
                    }
                    if (data.qtomConfig){
                        if (data.qtomConfig.qtomplusbutton && QTom.qtomPlusButton){
                            QTom.qtomPlusButton.setConfig(data.qtomConfig.qtomplusbutton);
                        }
                        if (data.qtomConfig.messages){
                            var messages = data.qtomConfig.messages, message;
                            for (id in messages){
                                if (messages.hasOwnProperty(id)){
                                    message = messages[id];
                                    if (message){
                                        QTom.message[id] = message;
                                    }
                                }
                            }
                        }
                    }
                    success.call(scope, data, result.id, xhr);
                }
            },
            scope:scope
        });
    },
    reinit: function(success, failure, scope){
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                action:'App_Service_Flake',
                method:'reinit'
            },
            failure: function(xhr){
                Tx.log('reinitcall failure', xhr);
                if (typeof  failure == 'function'){
                    failure.call(scope, xhr);
                }
            },
            success:function(xhr, result){
                Tx.log('reinitcall success', result, result.result.flake);
                var i, l, id;
                if (result.error || result.result.error){
                    failure.call(scope, xhr,result, result.error || result.result.error);
                }
                else {
                    var data = result.result;
                    if (data.world){
                        QTom.startChannel = null;
                        QTom.favoriteChannel = null;
                        var worlds = data.world;
                        QTom.worlds = [];
                        QTom.channels = [];
                        for (i= 0, l=worlds.length; i<l; i++){
                            QTom.worlds.push(new QTom.World(worlds[i])) ;
                        }
                    }
                    success.call(scope, data, result.id, xhr);
                }
            },
            scope:scope
        });
    },
    getPlaylist: function(channel, subchannel, success, failure, scope, clipId){
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[channel]':channel.id,
                'params[subchannel]':subchannel,
                'params[clipId]':clipId || '',
                action:'App_Service_Flake',
                method:'playlist'
            },
            failure:failure,
            success:function(xhr, result){
                if (result.error){
                    failure.call(scope, xhr,result, result.error);
                }
                else {
                    var data = result.result['playlist-result'], playlist = [];
                    if (data && data['@attributes'] && data['@attributes'].statuscode != QTom.STATUS_OK){
                        failure.call(scope, xhr, result, result.error);
                    }
                    else {
                        data = data ? data.asset : result.result.asset;
                        if (data){
                            for(var i= 0, l=data.length; i<l; i++){
                                playlist.push(new QTom.Asset(data[i]));
                            }
                        }
                    }
                    success.call(scope, playlist, result.id, xhr);
                    QTom.setNotifications(result.result.notifications);
                    QTom.setUserStatus(result.result);
                }
            },
            scope:scope
        });
    },
    getUpdatePlaylist: function(channel, subchannel, endtime, success, failure, scope){
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[channel]':channel.id,
                'params[subchannel]':subchannel,
                'params[endtime]':endtime,
                action:'App_Service_Flake',
                method:'updateplaylist'
            },
            failure:failure,
            success:function(xhr, result){
                if (result.error){
                    failure.call(scope, xhr,result, result.error);
                }
                else {
                    var data = result.result['playlist-result'], playlist = [];
                    if (data && data['@attributes'] && data['@attributes'].statuscode != QTom.STATUS_OK){
                        failure.call(scope, xhr, result, result.error);
                    }
                    else {
                        data = data ? data.asset : result.result.asset;
                        for(var i= 0, l=data.length; i<l; i++){
                            playlist.push(new QTom.Asset(data[i]));
                        }
                        success.call(scope, playlist, result.id, xhr);
                    }
                    QTom.setNotifications(result.result.notifications);
                    QTom.setUserStatus(result.result);
                }
            },
            scope:scope
        });
    },
    sendClipReport: function(asset, callback, scope){
        if (!asset || !asset.playPosition > 0 || !asset.isMusicClip()){
            if (typeof callback == 'function'){
                callback.call(scope || window);
            }
            return;
        }
        Tx.log('sendClipReport', asset.engineEntryId, Math.ceil(asset.playPosition / 1000));
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[duration]':Math.ceil(asset.playPosition / 1000),
                'params[playlistEntry]':asset.engineEntryId,
                action:'App_Service_Flake',
                method:'report'
            },
            success:callback,
            failure:callback,
            scope:scope
        })
    },
    /**
     *
     * @param {QTom.Channel} channel
     * @param {String} subchannel
     * @param {Function} callback
     * @param {Object} scope
     */
    keepalive: function(channel, subchannel, callback, scope){
        Tx.log('send keepalive', channel.id, subchannel);
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[channel]':channel.id,
                'params[subchannel]':subchannel,
                action:'App_Service_Flake',
                method:'keepalive'
            },
            success:function(xhr, result){
                if (result.result == 'wakeup') {
                    Tx.log('wake up');
                    window.location.reload();
                }
            },
            failure:callback,
            scope:scope
        });
    },
    login: function(tvcode, remember, callback, scope){
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[tvcode]':tvcode,
                'params[autologin]': remember ? 'true' : 'false',
                action:'App_Service_Flake',
                method:'login'
            },
            failure:function(){
                QTom.sessionId = null;
                QTom.loggedIn = false;
                callback.call(scope, false);

            },
            success:function(xhr, result){
                if (result.error){
                    QTom.sessionId = null;
                    QTom.loggedIn = false;
                    callback.call(scope, false, result, xhr);
                }
                else {
                    var data = result.result, status, content, userData = {};
                    if (data['login-result'] && data['login-result']['@attributes']) {
                        status = data['login-result']['@attributes']['statuscode'];
                        content = data['login-result']['content'];
                    }
                    if (status == 'FAIL'){
                        QTom.sessionId = null;
                        QTom.loggedIn = false;
                    }
                    else {
                        if (content){
                            userData['user-status'] = {
                                'status':status,
                                'session-token':content
                            };
                            QTom.setUserStatus(userData);
                            //QTom.loggedIn = true;
                            //QTom.sessionId = content;
                            //QTom.userStatus = status;
                        }
                        else {
                            QTom.sessionId = null;
                            QTom.loggedIn = false;
                        }
                    }
                    QTom.setNotifications(data.notifications);
                    callback.call(scope, QTom.loggedIn, result.id, xhr);
                }
            },
            scope:scope
        })
    },
    logout: function(callback, scope){
        callback = callback || Tx.empty;
        scope = scope|| window;
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[sessionId]':QTom.sessionId,
                action:'App_Service_Flake',
                method:'logout'
            },
            failure:function(){
                callback.call(scope, false);

            },
            success:function(xhr, result){
                if (result.error){
                    callback.call(scope, false, result, xhr);
                }
                else {
                    QTom.sessionId = null;
                    QTom.loggedIn = false;
                    callback.call(scope, QTom.loggedIn, result.id, xhr);
                }
                QTom.setNotifications(result.result.notifications);
            },
            scope:this
        });
    },
    getUserProfile: function(callback, scope){
        callback = callback || Tx.empty;
        scope = scope|| window;
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[sessionId]':QTom.sessionId,
                action:'App_Service_Flake',
                method:'getProfile'
            },
            failure:function(){
                callback.call(scope, false);

            },
            success:function(xhr, result){
                var data = result.result ? result.result['user-profile'] : null;
                if (result.error || !data){
                    callback.call(scope, false, result, xhr);
                }
                else {
                    callback.call(scope, data, result.id, xhr);
                }
            },
            scope:this
        });
    },
    getProviderStatus: function(success, failure, scope){
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[sessionId]':QTom.sessionId,
                action:'App_Service_Flake',
                method:'getProviderStatus'
            },
            failure:failure,
            success:function(xhr, result){
                if (result.error){
                    failure.call(scope, xhr,result, result.error);
                }
                else {
                    var data = result.result;
                    if (data['get-provider-status-result'] && data['get-provider-status-result']['@attributes'])
                    success.call(scope, data['get-provider-status-result']['@attributes'].statuscode, result.id, xhr);
                }
            },
            scope:scope
        });
    },
    publishMusicclip: function(asset, text, shareType, success, failure, scope){
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[playlistEntry]':asset.engineEntryId ? asset.engineEntryId : asset.id,
                'params[shareType]':shareType,
                'params[sessionToken]':QTom.sessionId,
                'params[text]':text,
                action:'App_Service_Flake',
                method:'publishMusicclip'
            },
            failure:failure,
            success:function(xhr, result){
                if (result.error){
                    failure.call(scope, xhr,result, result.error);
                }
                else {
                    var data = result.result;
                    data = (data['publish-result'] && data['publish-result']['@attributes'] && data['publish-result']['@attributes'].statuscode == 'OK') ? true : false;
                    success.call(scope, data, result.id, xhr);
                    QTom.setNotifications(result.result.notifications);
                }
            },
            scope:scope
        });
    },
    findChannel: function(clipId, success, failure, scope){
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[clipId]':clipId,
                action:'App_Service_Flake',
                method:'findChannel'
            },
            failure:failure,
            success:function(xhr, result){
                var res = result.result;
                if (result.error || !res.channel || !res.subchannel || !res.world){
                    failure.call(scope, xhr,result, result.error);
                }
                else {
                    var data = result.result;
                    success.call(scope || window, data, result.id, xhr);
                }
            },
            scope:scope
        });
    },
    register: function(email, success, failure, scope){
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[email]':email,
                action:'App_Service_Flake',
                method:'register'
            },
            failure:failure,
            success:function(xhr, result){
                var res = result.result;
                if (result.error){
                    failure.call(scope, xhr,result, result.error);
                }
                else {
                    var data = result.result;
                    if (data['register-result'] && data['register-result']['statuscode']){
                        data = data['register-result']['statuscode'];
                    }
                    else {
                        data = false;
                    }
                    success.call(scope || window, data, result.id, xhr);
                    QTom.setNotifications(result.result.notifications);
                }
            },
            scope:scope
        });
    },
    loadAsset: function(clipId, channel, subchannel, success, failure, scope){
        var load = function(clipId, channel, subchannel, world){
            new Tx.Ajax().request({
                url: TXConfig.serverUrl,
                params: {
                    useParams:'1',
                    id:QTom.requestId++,
                    'params[client]':QTom.getClientName(),
                    'params[channel]':channel.id,
                    'params[subchannel]':subchannel,
                    'params[clipId]':clipId,
                    action:'App_Service_Flake',
                    method:'playlistForAsset'
                },
                failure:failure,
                success:function(xhr, result){
                    if (result.error || !result.result['playlist-result'] ){
                        failure.call(scope, xhr,result, result.error);
                    }
                    else {
                        var data = result.result['playlist-result'].asset, playlist = [], res;
                        if (data){
                            for(var i= 0, l=data.length; i<l; i++){
                                playlist.push(new QTom.Asset(data[i]));
                            }
                        }
                        res = {
                            world:world,
                            channel:channel,
                            subchannel:subchannel,
                            playlist:playlist
                        };
                        success.call(scope, res, result.id, xhr);
                        QTom.setNotifications(result.result.notifications);
                        QTom.setUserStatus(result.result);
                    }
                },
                scope:scope
            });
        };
        if (!channel){
            QTom.findChannel(clipId, function(data){
                var channel, subchannel, world;
                world = QTom.getWorld(data.world.id) || data.world;
                channel = QTom.getChannel(data.channel.id) || new QTom.Channel(world, data.channel);
                subchannel = data.subchannel || channel.getDefaultSubchannel();
                    load(clipId, channel, subchannel, world);

            },
            function(){
                if (typeof failure == 'function'){
                    failure.apply(scope || window, arguments);
                }
            },this);
        }
        else {

        }
    },
    addToPlaylist: function(asset, success, failure, scope){
        if (!QTom.favoriteChannel){
            failure.call(scope, null, null, 'NO CHANNEL');
        }
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                'params[channelId]':QTom.favoriteChannel.id,
                'params[assetId]':asset.engineEntryId,
                action:'App_Service_Flake',
                method:'addToPlaylist'
            },
            failure:failure,
            success:function(xhr, result){
                var res = result.result;
                if (result.error){
                    failure.call(scope, xhr,result, result.error);
                }
                else {
                    var data = result.result, asset;
                    if (data['addToPlaylist-result'] && data['addToPlaylist-result']['@attributes'] && data['addToPlaylist-result']['@attributes']['statuscode']){
                        asset = data['addToPlaylist-result']['asset'];
                        data = data['addToPlaylist-result']['@attributes']['statuscode'];
                    }
                    else {
                        data = false;
                    }
                    success.call(scope || window, data, asset,  result.id, xhr);
                }
                QTom.setNotifications(result.result.notifications);

            },
            scope:scope
        });

    },
    removeFromPlaylist: function(asset, success, failure, scope){
        if (!QTom.favoriteChannel){
            failure.call(scope, null, null, 'NO CHANNEL');
        }
        new Tx.Ajax().request({
            url: TXConfig.serverUrl,
            params: {
                useParams:'1',
                id:QTom.requestId++,
                'params[client]':QTom.getClientName(),
                //'params[channelId]':QTom.favoriteChannel.id,
                'params[assetId]':asset.engineEntryId,
                action:'App_Service_Flake',
                method:'removeFromPlaylist'
            },
            failure:failure,
            success:function(xhr, result){
                var res = result.result;
                if (result.error){
                    failure.call(scope, xhr,result, result.error);
                }
                else {
                    var data = result.result;
                    if (data['removeFromPlaylist-result'] && data['removeFromPlaylist-result']['@attributes'] && data['removeFromPlaylist-result']['@attributes']['statuscode']){
                        data = data['removeFromPlaylist-result']['@attributes']['statuscode'];
                    }
                    else {
                        data = false;
                    }
                    success.call(scope || window, data, result.id, xhr);
                }
                QTom.setNotifications(result.result.notifications);

            },
            scope:scope
        });

    }
});

Tx.apply(QTom, {
    isBuffering: false,
    videoCounter:0,
    channelVideoCounter:0,
    subChannelVideoCounter:0,
    getWorld: function(id){
        for (var i= 0, l=QTom.worlds.length; i<l; i++){
            if (QTom.worlds[i].id == id){
                return QTom.worlds[i];
            }
        }
        return null;
    },
    getChannel: function(id){
        for (var i= 0, l=QTom.channels.length; i<l; i++){
            if (QTom.channels[i].id == id){
                return QTom.channels[i];
            }
        }
        return null;
    },
    getWorldByName: function(name){
        name = name.toLowerCase();
        for (var i= 0, l=QTom.worlds.length; i<l; i++){
            if (QTom.worlds[i].name.toLowerCase() == name){
                return QTom.worlds[i];
            }
        }
        return null;
    },
    getChannelByName: function(name){
        name = name.toLowerCase();
        for (var i= 0, l=QTom.channels.length; i<l; i++){
            if (QTom.channels[i].name.toLowerCase() == name){
                return QTom.channels[i];
            }
        }
        return null;
    },
    getMessage: function(id){
        Tx.log('getMessage', id, QTom.message);
        return QTom.message[id];
    },
    showMessage: function(message, callback, scope){
        callback = callback || function(action, data, button){
            QTom.smallNotification.hide();
            if (button.content){
                QTom.handleNotificationAction(button.content);
            }
        };
        scope = scope || QTom;
        if (typeof message == 'string'){
            message = QTom.getMessage(message);
        }
        if (QTom.smallNotification && message){
            QTom.smallNotification.show(message.headline, message.text, message.button,'',callback, scope);
        }
    },
    checkHasBuffering: function() {
        if (Tx.Device.isFirefox() || Tx.Device.isTechnisat() || Tx.Device.isVestel() || Tx.Device.isKeenhigh() || Tx.Device.isIkea()){
            QTom.hasBuffering = false;
        }
        var ua = navigator.userAgent, tests = [
            'Opera/9.80 (Linux i686; U; HbbTV/1.1.1(;;;;;); CE-HTML; TechniSat DIGIT ISIO S; de) Presto/2.5.21 Version/10.30',
            'Opera/9.80 (Linux i686; U; HbbTV/1.1.1(;;;;;); CE-HTML; TechniSat DIGIT ISIO C; de) Presto/2.5.21 Version/10.30',
            'Opera/9.80 (Linux i686; U; HbbTV/1.1.1(;;;;;); CE-HTML; TechniSat DigiCorder ISIO S; de) Presto/2.5.21 Version/10.30',
            'Opera/9.80 (Linux i686; U; HbbTV/1.1.1(;;;;;); CE-HTML; TechniSat DigiCorder ISIO C; de) Presto/2.5.21 Version/10.30',
            'Opera/9.80 (Linux sh4 ; U; HbbTV/1.1.1(;;;;;); CE-HTML; TechniSat DIGIT ISIO S; de) Presto/2.9.167 Version/11.50',
            'Opera/9.80 (Linux sh4 ; U; HbbTV/1.1.1(;;;;;); CE-HTML; TechniSat DIGIT ISIO C; de) Presto/2.9.167 Version/11.50',
            'Opera/9.80 (Linux sh4 ; U; HbbTV/1.1.1(;;;;;); CE-HTML; TechniSat DigiCorder ISIO S; de) Presto/2.9.167 Version/11.50',
            'Opera/9.80 (Linux sh4 ; U; HbbTV/1.1.1(;;;;;); CE-HTML; TechniSat DigiCorder ISIO C; de) Presto/2.9.167 Version/11.50',
            'Opera/9.80 (Linux sh4 ; U; HbbTV/1.1.1(;;;;;); CE-HTML; TechniSat DIGIT ISIO S; de) Presto/2.9.167 Version/11.50'
        ];
        if (ua.match(/TechniSat/i)){
            QTom.hasBuffering = false;
        }
        //ua = 'Opera/9.80 (Linux i686; U; HbbTV/1.1.1(;;;;;); CE-HTML; TechniSat DIGIT ISIO S; de) Presto/2.5.21 Version/10.30';
        for (var i= 0, l=tests.length; i<l; i++){
            if (ua == tests[i]){
                QTom.hasBuffering = false;
                return;
            }
        }
    },
    hasExitButton: function() {
        return Tx.Device.isFirefox() || Tx.Device.isPhilips();
    },
    getDeviceId: function(){
        var id = Tx.getCookie('txDeviceId');
        if (!id || id==0){
            var date = Tx.TODAY || new Date(), platform = Tx.Device.getPlatform(), version = Tx.Device.getVersion();
            id = platform +'-'+date.getFullYear()+'-'+date.getTime()+'-'+(parseInt(Math.random()*10000));
            //id = 'test-device';
            Tx.setCookie('txDeviceId', id, Date.txAdd(date, Date.TX_YEAR, 10));
        }
        return id;
    },
    getClientName: function(){
        return Tx.Device.getPlatform();
    },
    setCurrentUser: function(user){
        Tx.log('setCurrentUser', user);
        var el = Tx.fly('username');
        if (user){
            if (el){
                el.setHtml(Tx.htmlspecialchars(user['login-name']));
            }
            QTom.currentUser = user;
        }
        else {
            if (el){
                el.setHtml('');
            }
            QTom.currentUser = null;
        }
    },
    getVideoUrl: function(url){
        return String(url).replace('http://c26003-o.l.core.cdn.streamfarm.net','http://c26003-os.d.core.cdn.streamfarm.net');
        return String(url).replace('http://192.168.178.58/progressivD/assets/mp4/',QTom.mediaBaseUrl+'mp4/');
    },
    getMediaUrl: function(url) {
        return url ? QTom.mediaBaseUrl+url : '';
    },
    getBaseUrl: function(){
        var href = window.location.href;
        if (!href){
            return './';
        }
        href = href.replace(/\/index\.(html|php).*/,'');
        return href;
    },
    parseText: function(text){
        var allowed = ['ul','ol','li','p','h1','h2','h3','h4','h5','h6','strong','b','i','center','br'];
        return Tx.htmlspecialchars(text).replace(/\[([^\]]*?)\]/g,function(complete, match){

            if (match.match(/img src="[^"]*?\.(png|jpeg|jpg|gif)"/i)){
                return '<'+match+'/>';
            }
            match = match.toLowerCase();
            switch(match){
                case 'br': return '<br />';
                default:
                    if (match.charAt(0) == '/'){
                        return allowed.indexOf(match.substr(1)) == -1 ? complete : '<'+match+'>';
                    }
                    else {
                        return allowed.indexOf(match) == -1 ? complete : '<'+match+'>';
                    }
            }
        });
    },
    setChannelBackground: function(url){
        var el;
        if (!url || url === false){
            if (Tx.Device.isSamsung()){
                el = Tx.fly('application');
            }
            else {
                el = Tx.fly(Tx.getBody());
            }
            el.dom.style.backgroundImage = null;
            el.dom.style.background = null;
            return;
        }
        var imgUrl = QTom.getMediaUrl(url);
        Tx.log('setChannelBackground', imgUrl, 'backgroundImage', 'url('+imgUrl+')');
        //alert('setChannelBackground '+'url('+imgUrl+')');
        if (Tx.Device.isSamsung()){
            QTom.setElementBackgroundImage('application',imgUrl);
        }
        else {
            QTom.setElementBackgroundImage(Tx.getBody(),imgUrl);
        }
    },
    setStationLogo: function(url) {
        url = QTom.getMediaUrl(url);
        var el = Tx.fly('station-logo');
        if (url ){
            if (url != QTom.currentStationLogo) {
                QTom.currentStationLogo = url;
                Tx.log('setStationLogo url', url);
                el.attr('src', url);
            }
        }
        else {
            if (QTom.userStatus == QTom.USER_STATUS_PREMIUM){
                if (QTom.currentStationLogo != QTom.defaultPremiumStationLogo){
                    QTom.currentStationLogo = QTom.defaultPremiumStationLogo;
                    Tx.log('setStationLogo premium', QTom.defaultPremiumStationLogo);
                    el.attr('src', QTom.defaultPremiumStationLogo);
                }
            }
            else {
                if (QTom.currentStationLogo != QTom.defaultStationLogo){
                    QTom.currentStationLogo = QTom.defaultStationLogo;
                    Tx.log('setStationLogo default', QTom.defaultStationLogo);
                    el.attr('src', QTom.defaultStationLogo);
                }
            }
        }
    },
    setElementBackgroundImage: function(id, url){
        var el = Tx.fly(id);
        if (url){
            el.setStyle('backgroundImage', 'url('+url+')');
        }
        else {
            el.dom.style.background = null;
            el.dom.style.backgroundImage = null;
        }
    },
    setChannelImages: function(channel){
        Tx.log('setChannelImages', channel);
        var stationImage = channel.stationImage ? QTom.getMediaUrl(channel.stationImage) : (channel.world.stationImage ? QTom.getMediaUrl(channel.world.stationImage): ''),
            channelSelectionBackgroundImage = channel.channelSelectionBackgroundImage ? QTom.getMediaUrl(channel.channelSelectionBackgroundImage) : (channel.world.channelSelectionBackgroundImage ? QTom.getMediaUrl(channel.world.channelSelectionBackgroundImage): ''),
            clipInfoBackgroundImage = channel.clipInfoBackgroundImage ? QTom.getMediaUrl(channel.clipInfoBackgroundImage) : (channel.world.clipInfoBackgroundImage ? QTom.getMediaUrl(channel.world.clipInfoBackgroundImage): ''),
            worldMenuBackgroundImage = channel.worldMenuBackgroundImage ? QTom.getMediaUrl(channel.worldMenuBackgroundImage) : (channel.world.worldMenuBackgroundImage ? QTom.getMediaUrl(channel.world.worldMenuBackgroundImage): ''),
            controllerBackgroundImage = channel.controllerBackgroundImage ? QTom.getMediaUrl(channel.controllerBackgroundImage) : '';
        QTom.setChannelBackground(channel.backgroundImage || false);
        QTom.setSubchannelLogo(channel.logoImage);
        QTom.setStationLogo(channel.stationImage || channel.world.stationImage);
        //QTom.setElementBackgroundImage('station-image', stationImage);
        //QTom.setElementBackgroundImage('channel-branding', stationImage);

        QTom.assetInfo.setBackground(clipInfoBackgroundImage);

        //QTom.setElementBackgroundImage('channel-selection-header', channelSelectionBackgroundImage);
        Tx.fly('channel-selection-header-background').attr('src', channelSelectionBackgroundImage ? channelSelectionBackgroundImage : '');
        //QTom.setElementBackgroundImage('playercontrol-cliptitling', clipInfoBackgroundImage);
        //Tx.fly('playercontrol-cliptitling-background').attr('src', clipInfoBackgroundImage || '');
        //Tx.fly('channel-controller')[controllerBackgroundImage ? 'addClass' : 'removeClass']('user-image');
        //QTom.setElementBackgroundImage('channel-controller', controllerBackgroundImage);
        Tx.fly('channel-controller-bg-image').attr('src',controllerBackgroundImage || 'img/nix.gif');
        //QTom.setElementBackgroundImage('marketing-menu', worldMenuBackgroundImage);
        Tx.fly('marketing-menu').attr('src', worldMenuBackgroundImage || 'img/nix.gif');
    },
    setWorldImages: function(world){
        Tx.log('setWorldImages', world);
        var stationImage = world.stationImage ? QTom.getMediaUrl(world.stationImage) : '',
            channelSelectionBackgroundImage = world.channelSelectionBackgroundImage ? QTom.getMediaUrl(world.channelSelectionBackgroundImage): '',
            worldMenuBackgroundImage = world.worldMenuBackgroundImage ? QTom.getMediaUrl(world.worldMenuBackgroundImage): '',
            clipInfoBackgroundImage = world.clipInfoBackgroundImage ? QTom.getMediaUrl(world.clipInfoBackgroundImage): '';
        //QTom.setElementBackgroundImage('station-image', stationImage);
        //Tx.fly('channel-selection-header-background').attr('src', channelSelectionBackgroundImage ? channelSelectionBackgroundImage : '');
        //QTom.setElementBackgroundImage('channel-selection-header', channelSelectionBackgroundImage);
        QTom.setStationLogo(world.stationImage);
        QTom.setChannelBackground(world.backgroundImage);
        Tx.fly('channel-selection-header-background').attr('src', channelSelectionBackgroundImage ? channelSelectionBackgroundImage : '');

        QTom.assetInfo.setBackground(clipInfoBackgroundImage);

        //QTom.setElementBackgroundImage('playercontrol-cliptitling', clipInfoBackgroundImage);
        //Tx.fly('playercontrol-cliptitling-background').attr('src', clipInfoBackgroundImage || '');
        //QTom.setElementBackgroundImage('marketing-menu', worldMenuBackgroundImage);
        if (worldMenuBackgroundImage){
            Tx.fly('marketing-menu').attr('src', worldMenuBackgroundImage).show();
        }
        else {
            Tx.fly('marketing-menu').hide();
        }
    },
    setSubchannelLogo: function(src) {
        var mediaUrl = QTom.getMediaUrl(src);
        //QTom.setElementBackgroundImage('subchannel-logo',mediaUrl);
        if (mediaUrl){
            if (mediaUrl != QTom.currentSubchannelLogo){
                QTom.currentSubchannelLogo = mediaUrl;
                Tx.fly('channel-logo').attr('src',mediaUrl);
            }
        }
        else {
            if (QTom.currentSubchannelLogo != 'img/nix.gif'){
                QTom.currentSubchannelLogo = 'img/nix.gif';
                Tx.fly('channel-logo').attr('src','img/nix.gif');
            }
        }
    },
    setUpperThird: function(asset){
        var upperThird = asset.getUpperThird(), el = Tx.get('upper-third');
        Tx.log('upperThird', upperThird);
        if (upperThird){
            QTom.currentUpperThird = upperThird;
            el.attr('src', upperThird.url).show.delay(upperThird.fadeInAfter * 1000, el);
        }
        else {
            QTom.currentUpperThird = {};
            el.hide();
        }
    },
    isPremiumUser: function() {
        return QTom.userStatus == QTom.USER_STATUS_PREMIUM;
    },
    setExitButtonDisplay: function(state){
        var el = Tx.fly('application-exit');
        if (!el){
            return;
        }
        if (state === false){
            el.hide();
        }
        else {
            el[QTom.hasExitButton() ? 'show' : 'hide']();
        }
    },
    setPlaylistRemoveState: function(state){
        QTom.isRemoveState = !!state;
        TXApplication.page.playercontrol.setRemoveState(QTom.isRemoveState);
        TXApplication.fullscreenPlayerControl.setRemoveState(QTom.isRemoveState);
    },
    setPlaylistActiveState: function(state){
        TXApplication.page.playercontrol.setPlaylistActiveState(state);
        TXApplication.fullscreenPlayerControl.setPlaylistActiveState(state);
    },
    validateEmail: function(email){
        var re = /[a-z0-9!#$%&'*+\/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+\/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/;
        return email.match(re);
    },
    showLoading: function(x,y){
        if (!QTom.loadingIndicator){
            return;
        }
        if (Tx.typeOf(x) == 'element'){
            var pos = QTom.getElementPosition(x), loadEl = QTom.loadingIndicator.element.dom;
            x = pos.x+pos.w/2-loadEl.offsetWidth/2;
            y = pos.y+pos.h/2-loadEl.offsetHeight/2;
            QTom.loadingIndicator.show(x,y);
        }
        else if(x === 'playlist'){
            x = Tx.Device.isLowResolution() ? 1151*0.75 :1151;
            y = Tx.Device.isLowResolution() ? 521*0.75 :521;
            QTom.loadingIndicator.show(x,y);

        }
    },
    hideLoading: function() {
        if(QTom.loadingIndicator){
            QTom.loadingIndicator.hide();
        }
    },
    showBuffering: function(){
        if (!QTom.bufferingIndicator || QTom.isBuffering || TXApplication.popup || TXApplication.notification || !QTom.hasBuffering){
            return;
        }
        QTom.isBuffering = true;
        var x,y;
        if (Tx.fly(Tx.getBody()).hasClass('fullscreen')) {
            x = Math.floor(window.innerWidth/2)-60;
            y = Math.floor(window.innerHeight/2)-60;
        }
        else {
            var el = Tx.byId('videocontainer');
            x = el.offsetLeft + Math.floor(el.offsetWidth / 2) - (Tx.Device.isLowResolution() ? 45 :60);
            y = el.offsetTop + Math.floor(el.offsetHeight / 2) - (Tx.Device.isLowResolution() ? 45 :60);
        }
        QTom.bufferingIndicator.show(x,y);
    },
    hideBuffering: function() {
        if (QTom.bufferingIndicator && QTom.isBuffering){
            QTom.bufferingIndicator.hide();
            QTom.isBuffering = false;
        }
    },
    getElementPosition: function(element){
        var pos = {x:0,y:0, w:0, h:0}, body = Tx.getBody();
        if (!element.offsetHeight || element.offsetWidth){
            element = body;
        }
        pos.h = element.offsetHeight;
        pos.w = element.offsetWidth;
        while(element && element != body){
            pos.x += element.offsetLeft;
            pos.y += element.offsetTop;
            element = element.offsetParent;
        }
        return pos;
    },
    startTimer: function(name, fn, time, scope){
        QTom.stopTimer(name);
        QTom[name+'TimerInst'] = setTimeout(fn.bind(scope || window), time);
    },
    stopTimer: function(name){
        var timer = QTom[name+'TimerInst'];
        if (timer){
            clearTimeout(timer);
            QTom[name+'TimerInst'] = null;
        }
    },
    showNotifications: function(){
        if (TXApplication.playingAd){
            QTom.showNotifications.delay(30000, QTom);
        }
        if (QTom.smallNotification && QTom.notifications.length > 0){
            var notification = QTom.notifications.shift();
            /* test
            notification.button = {
                text:'login',
                content:'login:'
            }
            */
            QTom.smallNotification.show(notification.titleText, notification.messageText, notification.button, null, function(action, data, button, popup) {
                popup.hide();
                if (button.action == 'ok' && button.content){
                    QTom.handleNotificationAction(button.content, popup);
                }
                QTom.showNotifications.delay(1000, QTom);
            },QTom, QTom.getMediaUrl(notification.titleImage), QTom.getMediaUrl(notification.messageImage));
        }
    },
    handleNotificationAction: function(content, popup){
        /*
        channel://123456
        clip://kdjaksdjhkdjfaskfd
        login://
         */
        var temp;
        content = String(content);
        if (content.indexOf('http') === 0){
            window.location.href = content;
        }
        else if (content.indexOf('clip://') === 0){
            temp = content.substr(7).split('/');
            TXApplication.loadAsset(temp[0], temp[1], temp[2]);
        }
        else if(content.indexOf('channel://') === 0){
            temp = content.substr(10).split(/[\/_]/);
            TXApplication.loadChannel(temp[0], temp[1] || '333');
        }
        else if(content.indexOf('login:')=== 0){
            TXApplication.showLogin();
        }
    },
    formatSeconds: function(sec){
        sec = parseInt(sec) || 0;
        var hours = Math.floor(sec / 60), secs = sec - hours * 60;
        return secs < 10 ? hours+':0'+secs : hours+':'+secs;
    },
    updateTextMessage: function(message, prefix){
        if (typeof message == 'string'){
            prefix = message+'-';
            message = QTom.getMessage(message);
        }
        if (!message){
            return;
        }
        var key, text, el;
        for (key in message){
            text = message[key];
            if (!text){
                continue;
            }
            text = QTom.parseText(text);
            el = Tx.fly(prefix+key);
            if (el && el.dom){
                el.setHtml(text);
            }
        }

    }
});

Tx.override(Tx.Component, {
    setSelected: function(state){
        if (this.element){
            if (state){
                this.element.setSelected(true);
                if (this.removeSelected) {
                    this.element.setSelected.delay(500, this.element, false);
                }
            }
            else {
                this.element.setSelected(false);
            }
        }
    }
});
Tx.Animate = Tx.extend(Tx.Base, {
    constructor: function(options){
        Tx.Base.prototype.constructor.apply(this, arguments);
        Tx.apply(this, options);
    },
    animate: function(obj, prop, duration, start, end, unit, callback, scope){
        this.startValue = start;
        this.endValue = end;
        this.obj = obj;
        this.prop = prop;
        this.startTime = new Date().getTime();
        this.endTime = new Date(this.startTime + duration);
        this.unit = unit;
        this.callback = callback;
        this.scope = scope;
        this.start();
    },
    onTimer: function() {
        var start=this.startValue, end=this.endValue, obj = this.obj, prop = this.prop, unit=this.unit,
            startTime = this.startTime, endTime = this.endTime, currTime = new Date().getTime(),
            mul = (currTime - startTime) / (endTime - startTime), val = (end - start) * mul + start;
        if (currTime >= endTime){
            this.stop();
            obj[prop] = end+unit;
            if (typeof this.callback == 'function'){
                this.callback.call(this.scope || this, this);
            }
            return;
        }
        obj[prop] = val+unit;
    },
    start: function() {
        if (this.timer){
            this.stop();
        }
        this.timer = setInterval(this.onTimer.bind(this), 50);
    },
    stop: function(){
        if(this.timer){
            clearInterval(this.timer);
        }
    }
});