/**
 * Created with JetBrains PhpStorm.
 * User: kasi
 * Date: 03.06.12
 * Time: 19:04
 * To change this template use File | Settings | File Templates.
 */
Tx.Device.init();
Tx.Device.b_keyboard = true;
QTom.inToolsMenu = false;
Tx.apply(Tx.Application.prototype, {
    onLoad: function() {
        alert('onLoad');
        window.onshow = window.onShow = this.onShow.bind(this);
        this.pluginAPI = Tx.Samsung.pluginAPI;
        this.tvKey = Tx.Samsung.tvKey;
        this.widgetApi = Tx.Samsung.widgetAPI;
        this.widgetApi.sendReadyEvent();
        alert('sendReadyEvent');
        this.videoPlayer = new Tx.Video(this.videoCfg);
        this.videoPlayer.init();
        this.network = Tx.Samsung.Network;
        this.network.init();
        this.network.addEvent('disconnect', this.onDisconnect.bind(this));
        this.network.addEvent('connect', this.onConnect.bind(this));
        if (this.network.checkConnection()){
            this.onConnect();
        }
        this.NNaviPlugin = Tx.Samsung.NNaviPlugin =  Tx.byId(this.pluginNNaviID);
        this.initKeys();
        this.initApplication();
        this.initNavigation();
        this.NNaviPlugin.SetBannerState(2);
        this.pluginAPI.SetBannerState(1);
        this.pluginAPI.unregistKey(this.tvKey.KEY_VOL_UP);
        this.pluginAPI.unregistKey(this.tvKey.KEY_VOL_DOWN);
        this.pluginAPI.unregistKey(this.tvKey.KEY_MUTE);
        alert('ready');
    }
});

Tx.apply(QTom, {
    getDeviceId: function() {
        var id = Tx.Samsung.getDeviceId();
        if (!id){
            Tx.reload();
        }
        return 'samsung-'+ id;
    }
});

Tx.Textfield = Tx.extend(Tx.Component, {
    keyboardVisible:false,
    keyboardMode: 'default',
    emptyValue:'',
    txType: 'textfield',
    imeReady: false,
    constructor: function(id, options){
        Tx.Component.prototype.constructor.apply(this, arguments);
        this.input = Tx.get(this.input);
        alert('init textfield '+this.input.getId());
        this.ime = new IMEShell(this.input.getId(), this.imiReady.bind(this), 'de');
        this.setValue(this.value || this.emptyValue);
        this.anchor = Tx.byId('dummy-ime-anchor');
        this.anchor.focus();
    },
    imiReady: function(imiObj){
        alert('ime ready '+this.input.id);
        var tvKey = Tx.Samsung.tvKey;
        this.imeReady = true;
        this.ime.setKeyFunc(tvKey.KEY_UP, this.onImeKey.bind(this));
        this.ime.setKeyFunc(tvKey.KEY_DOWN, this.onImeKey.bind(this));
        this.ime.setKeyFunc(tvKey.KEY_RIGHT, this.onImeKey.bind(this));
        this.ime.setKeyFunc(tvKey.KEY_LEFT, this.onImeKey.bind(this));
        this.ime.setKeyFunc(tvKey.KEY_RETURN, this.onImeKey.bind(this));
        this.ime.setKeyFunc(tvKey.KEY_EXIT, this.onImeKey.bind(this));
        this.ime.setKeyFunc(tvKey.KEY_TOOLS, this.onImeKey.bind(this));
        //this.ime.setKeypadPos(666, 80, 100); // (x, y, z-index)
        //this.ime.setWordBoxPos(560, 40, 100); // (x, y, z-index)
        //this.ime.setKeySetFunc('qwerty');
        this.ime.setAnyKeyFunc(this.onAnyKey.bind(this));
        this.ime.setMaxLengthFunc(this.onMaxLength.bind(this));
        this.ime.setPrevEventOnLeftFunc(this.onLeft.bind(this));
        this.ime.setOnCompleteFunc(this.onComplete.bind(this));
        this.ime.setEnterFunc(this.onEnter.bind(this));
        this.ime.setKeyFunc(tvKey.KEY_INFO, this.onImeKey.bind(this));
        this.input.dom.blur();
        this.anchor.focus();
        if (this.ime.setMaxlength){
            this.ime.setMaxlength(100);
        }
        else {
            this.ime.maxLength = 100;
        }
    },
    onImeKey: function(keyCode){
        var tvKey = Tx.Samsung.tvKey;
        switch(keyCode){
            case tvKey.KEY_ENTER:
            case tvKey.KEY_RETURN: QTom.inToolsMenu = false; this.fireEvent('enter'); break;
            case tvKey.KEY_EXIT: this.fireEvent('exit'); break;
            case tvKey.KEY_TOOLS:
                QTom.inToolsMenu = true;
                return true;
        }
        QTom.inToolsMenu = false;
        alert('onImeKey '+keyCode);
        return false;
    },
    onAnyKey: function(keyCode){
    },
    onMaxLength: function(){
        return false;
    },
    onLeft: function(){
        alert('onLeft');
    },
    onComplete: function(data){
        alert('onComplete '+data);
    },
    onEnter: function(keyCode){
        alert('onEnter '+keyCode);
    },
    getValue: function(){
        return this.input.dom.value || '';
    },
    setValue: function(value){
        if (value == ''){
            value = this.emptyValue;
        }
        this.value = value;
        this.setFieldValue(value);
        if (value == this.emptyValue || value == ''){
            this.input.addClass('empty');
        }
        else {
            this.input.removeClass('empty');
        }
    },
    setFieldValue: function(value) {
        if (!this.imeReady){
            this.setFieldValue.delay(1000, this, value);
        }
        this.ime.setString(value);
    },
    setFocus: function(state){
        alert('focus'+state);
        if (this.ime){
            this.ime.setKeypadPos(666, 80, 100); // (x, y, z-index)
        }
        Tx.Component.prototype.setFocus.apply(this, arguments);
        if (!!state){
            this.input.dom.focus();
        }
        else {
            this.input.dom.blur();
            this.anchor.focus();
        }
    },
    addString: function(str) {
        var value = this.getValue();
        if (value == this.emptyValue){
            value = str;
        }
        else {
            value = value + str;
        }
        this.setValue(value);
    },
    backspace: function() {
        var value = this.getValue();
        if (value.length > 0){
            value = value.substr(0,value.length-1);
            this.setValue(value);
        }
    },
    clear: function() {
        this.setValue(this.emptyValue);
    },
    hideKeyboard: Tx.empty,
    showKeyboard: Tx.empty
});

QTom.Textfield = Tx.extend(Tx.Textfield, {

});
