/**
 * Created by JetBrains PhpStorm.
 * User: kasi
 * Date: 08.08.11
 * Time: 16:11
 * To change this template use File | Settings | File Templates.
 */

(function(map){
    map[VK_LEFT] =TX_KEY_LEFT;
    map[VK_RIGHT] =TX_KEY_RIGHT;
    map[VK_UP] =TX_KEY_UP;
    map[VK_DOWN] =TX_KEY_DOWN;
    map[VK_ENTER] =TX_KEY_ENTER;
    map[VK_0] =TX_KEY_0;
    map[VK_1] =TX_KEY_1;
    map[VK_2] =TX_KEY_2;
    map[VK_3] =TX_KEY_3;
    map[VK_4] =TX_KEY_4;
    map[VK_5] =TX_KEY_5;
    map[VK_6] =TX_KEY_6;
    map[VK_7] =TX_KEY_7;
    map[VK_8] =TX_KEY_8;
    map[VK_9] =TX_KEY_9;
    map[VK_RED] =TX_KEY_RED;
    map[VK_GREEN] =TX_KEY_GREEN;
    map[VK_YELLOW] =TX_KEY_YELLOW;
    map[VK_BLUE] =TX_KEY_BLUE;
    map[VK_PLAY] =TX_KEY_PLAY;
    map[VK_STOP] =TX_KEY_STOP;
    map[VK_PAUSE] =TX_KEY_PAUSE;
    map[VK_REWIND] =TX_KEY_REWIND;
    map[VK_FAST_FWD] =TX_KEY_FORWARD;
    map[VK_INFO] =TX_KEY_INFO;
    map[VK_BACK] =TX_KEY_BACK;
    map[VK_EXIT] =TX_KEY_EXIT;
    map[VK_VOLUME_UP] =TX_KEY_VOLUME_UP;
    map[VK_VOLUME_DOWN] =TX_KEY_VOLUME_DOWN;
    map[VK_CHANNEL_UP] =TX_KEY_CHANNEL_UP;
    map[VK_CHANNEL_DOWN] =TX_KEY_CHANNEL_DOWN;
    map[VK_MUTE] =TX_KEY_MUTE;
})(Tx.Remote.prototype.map);
/**
 * Created by JetBrains PhpStorm.
 * User: kasi
 * Date: 28.07.11
 * Time: 17:58
 * To change this template use File | Settings | File Templates.
 */

Tx.override(Tx.Video, {
    containerId: 'videocontainer',
    checkTimer: null,
    checkInterval: 1000,
    playRetry: 10,
    toggleOnPause: true,
    duration: 0,
    getContainer: function() {
        return this.container || (this.container = Tx.get(this.containerId));
    },
    load: function(video, isLivestream){
        this.stop();
        this.duration = 0;
        this.isLivestream = (isLivestream === true);
        this.playRetry = 10;
        var container = this.getContainer();
        if (typeof video == 'string'){
            video = {
                url: video,
                mime:'video/mp4'
            }
        }
        Tx.log('Video load '+video.url + ' '+video.mime);
        this.state = TX_STATE_STOPPED;
        this.video = video;
        this.videoObject = document.createElement("object");  // create new object
        this.videoObject.setAttribute("id", "video");
        this.videoObject.setAttribute("type", video.mime); // set correct mimetype
        this.videoObject.setAttribute("data", video.url);
        this.videoObject.setAttribute("false", "true");
        this.videoObject.setAttribute("uiMode", "mini");

        container.setHtml('');
        container.dom.appendChild(this.videoObject);
        //if (!(this.isLivestream && Tx.Device.isLoewe())){
            this.videoObject.onPlayStateChange = this.onPlayStateChange.bind(this);
        //}
        this.fireEvent('load', [video]);
        Tx.log(container.dom.innerHTML);
    },
    playLivestream: function(video){
        if (typeof video == 'string'){
            video = {
                url: video,
                mime:'video/x-ms-wmv'
            }
        }
        this.load(video, true);
        this.play();
    },
    play: function() {
        if (!this.videoObject || !this.videoObject.play){
            return;
        }
        Tx.log('Play '+this.video.url);
        try {
            this.videoObject.play(1);
            Tx.log('Video playing');
        }
        catch(e){
            Tx.log('Play exception '+e);
            this.playRetry--;
            if (this.playRetry > 0){
                this.play.delay(500, this);
            }
        }
    },
    stop: function() {
        this.stopCheckTimer();
        if (!this.videoObject || !this.videoObject.stop){
            return;
        }
        try  {
            this.videoObject.onPlayStateChange = Tx.empty;
            switch(this.videoObject.playState) {
                case TX_STATE_PLAYING:
                case TX_STATE_PAUSED:
                case TX_STATE_CONNECTING:
                case TX_STATE_BUFFERING:
                    this.videoObject.stop();
                    break;
            }
            this.videoObject = null;
            this.getContainer().setHtml('');
            this.state = TX_STATE_STOPPED;
        }
        catch(e){
            Tx.log(String(e));
        }
    },
    pause: function() {
        this.stopCheckTimer();
        if (!this.videoObject || !this.videoObject.play){
            return;
        }
        switch(this.videoObject.playState){
            case TX_STATE_STOPPED:
            case TX_STATE_PAUSED:
                if (this.toggleOnPause) {
                    this.videoObject.play(1);
                }
                break;
            case TX_STATE_PLAYING:
                this.videoObject.play(0);
                break;
        }
    },
    rewind: function(seconds){
        if (!this.videoObject || !this.videoObject.seek){
            return;
        }
        try {
            var newPosition = Math.max(0, this.videoObject.playPosition - seconds * 1000);
            Tx.log('pos '+newPosition);
            this.videoObject.seek(newPosition);

        }
        catch(e){
            Tx.log(String(e));
        }
    },
    forward: function(seconds){
        if (!this.videoObject || !this.videoObject.seek){
            return;
        }
        try {
            var newPosition = this.videoObject.playPosition + seconds * 1000;
            if (this.videoObject.playTime){
                newPosition = Math.min(this.videoObject.playTime, newPosition);
            }
            this.videoObject.seek(this.videoObject.playPosition + seconds * 1000);

        }
        catch(e){
            Tx.log(String(e));
        }
    },
    onPlayStateChange: function() {
        if (!this.videoObject){
            return;
        }
        var playState = this.videoObject.playState, fromState = this.state;
        Tx.log('statechanged '+fromState+ '=>' + playState);
        if (Tx.Device.isLoewe() && this.isLivestream && fromState == 4 && playState == 4){
            playState = TX_STATE_PLAYING;
        }
        this.fireEvent('statechanged', [playState, fromState]);
        this.state = playState;
        switch(playState){
            case TX_STATE_STOPPED:
                this.stopCheckTimer();
                break;
            case TX_STATE_PLAYING:
                this.startCheckTimer();
                break;
            case TX_STATE_PAUSED:
                this.stopCheckTimer();
                break;
            case TX_STATE_CONNECTING:
            case TX_STATE_BUFFERING:
                //this.stopCheckTimer();
                break;
            case TX_STATE_FINISHED:
                this.stopCheckTimer();
                this.fireEvent('finished');
                break;
            case TX_STATE_ERROR:
                this.stopCheckTimer();
                this.fireEvent('error', [this.videoObject.error, this.videoObject.errorMessage]);
                break;
        }
    },
    onCheckTimer: function() {
        var playPosition = this.videoObject.playPosition, playTime = this.videoObject.playTime || Number(this.duration), progress;
        if (playTime === 0){
            progress = -1;
        }
        else {
            progress = Math.round((playPosition / playTime)*100);
        }
        this.fireEvent('progress', [progress, playPosition, playTime]);
        //Tx.log('progress '+progress+ ' '+this.videoObject.playState+' '+playPosition+' '+playTime);
        if (Tx.Device.isLoewe() && this.isLivestream && progress == -1 && this.videoObject.playState == 4){
            this.state = TX_STATE_PLAYING;
            this.fireEvent('statechanged', [this.videoObject.playState, this.state]);
        }
    },
    setDimension:function(left, top, width, height) {
        if (!this.videoObject){
            return;
        }
        left = Math.min(window.innerWidth - 1, left);
        top	= Math.min(window.innerHeight - 1, top);
        width = Math.min((window.innerWidth - left), width);
        height = Math.min((window.innerHeight - top), height);
        this.videoObject.width = width;
        this.videoObject.height = height;
        var styles = {
            left:left+'px',
            top:top+'px',
            width:width+'px',
            height:height+'px'
        };
        this.container.setStyles(styles);
        Tx.fly(this.videoObject).setStyles(styles);
        Tx.log(this.container.dom.innerHTML);
    }
});
/**
 * Created by JetBrains PhpStorm.
 * User: kasi
 * Date: 10.08.11
 * Time: 14:46
 * To change this template use File | Settings | File Templates.
 */

Tx.override(Tx.Application, {

    onLoad: function() {
        Tx.log('onLoad');
        this.videoPlayer = new Tx.Video(this.videoCfg);
        this.videoPlayer.init();
        this.initApplication();
        this.initNavigation();
        this.onReady();
    }
});

